# Dashboard Example CBun

Dashboard Example CBun demonstrates the implementation of Custom Device Dashboard. The dashboard allows the user
online control of a virtual gripper, ie. the user can set and get the actual gripper width. The dashboard (frontend)
communicates with the gripper instance (backend) via the XML-RPC.  

![Dashboard Example CBun](/printscreen.png)

The Dashboard Example CBun consists of the backend (written in C++ and based on the [CBun Framework](https://docs.kassowrobots.com/en/cbuns/development)) and frontend (written in Kotlin and based on the [CBunX Framework](https://kassowrobots.gitlab.io/cbunx-api-doc/)).

## Git Clone on Windows

When using `git clone` command on Windows, the git may convert Unix-style `\n` line breaks to Windows-style `\r\n` line breaks on checking files out. Since the CBun build container is Unix based, this automatic line break conversion may cause issues during the CBun development. Therefore make sure that this behaviour is disabled prior cloning this CBun example project by running the following command: 

`git config --global core.autocrlf false`

## Frontend Build Environment

The Dashboard Example CBuns comes with the preconfigured frontend build environment which is based on the Android Studio. With this you can open and debug the CBun frontend on Windows, MacOS or Linux without the need for complicated build environment configuration. 

### Prerequisities

To get started, follow these steps:

1. Install the [Android Studio](https://developer.android.com/studio).

### Frontend Emulator Setup

By using the emulator (virtual device) you can test your UI directly on your development machine within the Android Studio. You need to configure the virtual device just once for all of your CBun frontend projects. To setup the emulator, follow these steps.

1. Open the CBun frontend subfolder in Android Studio. 

2. Open **Tools** -> **Device Manager** to configure an emulated virtual device for the standalone application test. Click **Create device** to add new virtual device.

3. Click **New Hardware Profile** to create new emulator profile, that will match the UI behaviour of the real robot in terms of the resolution and the density of pixels.

4. Enter the device name (for example CBun App Emulator) and configure the emulator resolution (932 x 987 px) and screen size (6.1”) to fit the CBun App container in the Teach Pendant host app. The click the **Finish** button.

5. Once the new hardware profile is added, select it and click the **Next** button.

6. Select the **Q** system image, since Android 10 ensures compatibility with the highest amount of our robots. Then click the **Next** button.

7. Check the device configuration, enter the AVD Name and click the **Finish** button.

8. Finally click the run app button (or Ctrl-R shortcut) to launch your application in the emulator.

## Backend Build Environment

The Dashboard Example CBuns comes with the preconfigured backend build environment which is based on **Visual Studio Code Dev Containers** extension. With this you can open, debug and build the CBun project on Windows, MacOS or Linux without the need for complicated build environment configuration. 

### Prerequisities

To get started, follow these steps:

1. Install and configure [Docker](https://www.docker.com/get-started) for your operating system, using one of the paths below.

   **Windows / macOS:**

   1. Install Docker [Desktop for Windows/Mac](https://www.docker.com/products/docker-desktop).

   2. If you are using Windows, enable WSL and make sure it is up to date by running the following Command Prompt: `wsl --update`

   **Linux:**

   1. Follow the [official install instructions for Docker CE/EE for your distribution](https://docs.docker.com/install/#supported-platforms).

   2. Add your user to the docker group by using a terminal to run: `sudo usermod -aG docker $USER`

   3. Sign out and back in again so your changes take effect.

2. Install [Visual Studio Code](https://code.visualstudio.com/) or [Visual Studio Code Insiders](https://code.visualstudio.com/insiders/).

3. Install the [Dev Containers extension](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-containers). 

### CBun Backend Setup

To setup the CBun project in Visual Studio Code, follow these steps:

1. Open your CBun project folder in Visual Studio Code.

2. Click **Yes, I trust the authors**.

3. Click **Reopen in Container** (this may take few minutes).

5. Select the **GCC 8.4.0 x86_64-linux-gnu** as the active Kit.

## CBun Assembly

The CBun installer (dashboard_example.cbun) is generated by the **CBun: Build** task in Visual Studio Code if the **Release** build variant is selected. Once the CBun is generated, it can be installed on the real robot from a USB stick or Google Drive.

Follow the steps bellow in order to generate and install the CBun:

1. Open the backend project in Visual Studio Code. 

2. Set **Release** build variant.

3. Run the **CBun: Build** task (**Terminal** -> **Run Task...** -> **CBun: Build**).

4. Copy the CBun installer (**PROJECT_FOLDER/build/dashboard_example.cbun**) to a USB stick.

5. Install the CBun on a real robot from the USB stick.
